diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ue-rrc.cc ns-3.36/src/lte/model/lte-ue-rrc.cc
--- ns-3.35/src/lte/model/lte-ue-rrc.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ue-rrc.cc	2022-04-30 18:23:58.050734500 -0700
@@ -2229,285 +2387,98 @@
                   default:
                     NS_FATAL_ERROR ("unsupported triggerQuantity");
                     break;
-                }
-
-              bool hasTriggered = isMeasIdInReportList
-                && (measReportIt->second.cellsTriggeredList.find (cellId)
-                    != measReportIt->second.cellsTriggeredList.end ());
-
-              // Inequality A4-1 (Entering condition): Mn + Ofn + Ocn - Hys > Thresh
-              bool entryCond = mn + ofn + ocn - hys > thresh;
-
-              if (entryCond)
-                {
-                  if (!hasTriggered)
-                    {
-                      concernedCellsEntry.push_back (cellId);
-                      eventEntryCondApplicable = true;
-                    }
-                }
-              else if (reportConfigEutra.timeToTrigger > 0)
-                {
-                  CancelEnteringTrigger (measId, cellId);
-                }
-
-              // Inequality A4-2 (Leaving condition): Mn + Ofn + Ocn + Hys < Thresh
-              bool leavingCond = mn + ofn + ocn + hys < thresh;
-
-              if (leavingCond)
-                {
-                  if (hasTriggered)
-                    {
-                      concernedCellsLeaving.push_back (cellId);
-                      eventLeavingCondApplicable = true;
-                    }
-                }
-              else if (reportConfigEutra.timeToTrigger > 0)
-                {
-                  CancelLeavingTrigger (measId, cellId);
-                }
-
-              NS_LOG_LOGIC (this << " event A4: neighbor cell " << cellId
-                                 << " mn=" << mn << " thresh=" << thresh
-                                 << " entryCond=" << entryCond
-                                 << " leavingCond=" << leavingCond);
-
-            } // end of for (storedMeasIt)
-
-        } // end of case LteRrcSap::ReportConfigEutra::EVENT_A4
-
-        break;
-
-      case LteRrcSap::ReportConfigEutra::EVENT_A5:
-        {
-          /*
-           * Event A5 (PCell becomes worse than threshold1 and neighbour
-           * becomes better than threshold2)
-           * Please refer to 3GPP TS 36.331 Section 5.5.4.6
-           */
-
-          double mp; // Mp, the measurement result of the PCell
-          double mn; // Mn, the measurement result of the neighbouring cell
-          double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
-          double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
-          double thresh1; // Thresh1, the threshold parameter for this event
-          double thresh2; // Thresh2, the threshold parameter for this event
-          // Hys, the hysteresis parameter for this event.
-          double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
-
-          switch (reportConfigEutra.triggerQuantity)
-            {
-              case LteRrcSap::ReportConfigEutra::RSRP:
-                mp = m_storedMeasValues[m_cellId].rsrp;
-                NS_ASSERT (reportConfigEutra.threshold1.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-                NS_ASSERT (reportConfigEutra.threshold2.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-                thresh1 = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
-                thresh2 = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold2.range);
-                break;
-              case LteRrcSap::ReportConfigEutra::RSRQ:
-                mp = m_storedMeasValues[m_cellId].rsrq;
-                NS_ASSERT (reportConfigEutra.threshold1.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-                NS_ASSERT (reportConfigEutra.threshold2.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-                thresh1 = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
-                thresh2 = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold2.range);
-                break;
-              default:
-                NS_FATAL_ERROR ("unsupported triggerQuantity");
-                break;
-            }
+                  }
 
-          // Inequality A5-1 (Entering condition 1): Mp + Hys < Thresh1
-          bool entryCond = mp + hys < thresh1;
+                bool hasTriggered = isMeasIdInReportList
+                  && (measReportIt->second.cellsTriggeredList.find (cellId)
+                      != measReportIt->second.cellsTriggeredList.end ());
+
+                // Inequality A5-2 (Entering condition 2): Mn + Ofn + Ocn - Hys > Thresh2
+
+                entryCond = mn + ofn + ocn - hys > thresh2;
+
+                if (entryCond)
+                  {
+                    if (!hasTriggered)
+                      {
+                        concernedCellsEntry.push_back (cellId);
+                        eventEntryCondApplicable = true;
+                      }
+                  }
+                else if (reportConfigEutra.timeToTrigger > 0)
+                  {
+                    CancelEnteringTrigger (measId, cellId);
+                  }
+
+                NS_LOG_LOGIC (this << " event A5: neighbor cell " << cellId
+                                   << " mn=" << mn << " mp=" << mp
+                                   << " thresh2=" << thresh2
+                                   << " thresh1=" << thresh1
+                                   << " entryCond=" << entryCond);
 
-          if (entryCond)
-            {
-              for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
-                   storedMeasIt != m_storedMeasValues.end ();
-                   ++storedMeasIt)
-                {
-                  uint16_t cellId = storedMeasIt->first;
-                  if (cellId == m_cellId)
-                    {
-                      continue;
-                    }
-
-                  switch (reportConfigEutra.triggerQuantity)
-                    {
-                      case LteRrcSap::ReportConfigEutra::RSRP:
-                        mn = storedMeasIt->second.rsrp;
-                        break;
-                      case LteRrcSap::ReportConfigEutra::RSRQ:
-                        mn = storedMeasIt->second.rsrq;
-                        break;
-                      default:
-                        NS_FATAL_ERROR ("unsupported triggerQuantity");
-                        break;
-                    }
-
-                  bool hasTriggered = isMeasIdInReportList
-                    && (measReportIt->second.cellsTriggeredList.find (cellId)
-                        != measReportIt->second.cellsTriggeredList.end ());
-
-                  // Inequality A5-2 (Entering condition 2): Mn + Ofn + Ocn - Hys > Thresh2
-
-                  entryCond = mn + ofn + ocn - hys > thresh2;
-
-                  if (entryCond)
-                    {
-                      if (!hasTriggered)
-                        {
-                          concernedCellsEntry.push_back (cellId);
-                          eventEntryCondApplicable = true;
-                        }
-                    }
-                  else if (reportConfigEutra.timeToTrigger > 0)
-                    {
-                      CancelEnteringTrigger (measId, cellId);
-                    }
-
-                  NS_LOG_LOGIC (this << " event A5: neighbor cell " << cellId
-                                     << " mn=" << mn << " mp=" << mp
-                                     << " thresh2=" << thresh2
-                                     << " thresh1=" << thresh1
-                                     << " entryCond=" << entryCond);
-
-                } // end of for (storedMeasIt)
-
-            } // end of if (entryCond)
-          else
-            {
-              NS_LOG_LOGIC (this << " event A5: serving cell " << m_cellId
-                                 << " mp=" << mp << " thresh1=" << thresh1
-                                 << " entryCond=" << entryCond);
-
-              if (reportConfigEutra.timeToTrigger > 0)
-                {
-                  CancelEnteringTrigger (measId);
-                }
-            }
-
-          if (isMeasIdInReportList)
-            {
-              // Inequality A5-3 (Leaving condition 1): Mp - Hys > Thresh1
-              bool leavingCond = mp - hys > thresh1;
-
-              if (leavingCond)
-                {
-                  if (reportConfigEutra.timeToTrigger == 0)
-                    {
-                      // leaving condition #2 does not have to be checked
-
-                      for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
-                           storedMeasIt != m_storedMeasValues.end ();
-                           ++storedMeasIt)
-                        {
-                          uint16_t cellId = storedMeasIt->first;
-                          if (cellId == m_cellId)
-                            {
-                              continue;
-                            }
-
-                          if (measReportIt->second.cellsTriggeredList.find (cellId)
-                              != measReportIt->second.cellsTriggeredList.end ())
-                            {
-                              concernedCellsLeaving.push_back (cellId);
-                              eventLeavingCondApplicable = true;
-                            }
-                        }
-                    } // end of if (reportConfigEutra.timeToTrigger == 0)
-                  else
-                    {
-                      // leaving condition #2 has to be checked to cancel time-to-trigger
+              } // end of for (storedMeasIt)
 
-                      for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
-                           storedMeasIt != m_storedMeasValues.end ();
-                           ++storedMeasIt)
-                        {
-                          uint16_t cellId = storedMeasIt->first;
-                          if (cellId == m_cellId)
-                            {
-                              continue;
-                            }
-
-                          if (measReportIt->second.cellsTriggeredList.find (cellId)
-                              != measReportIt->second.cellsTriggeredList.end ())
-                            {
-                              switch (reportConfigEutra.triggerQuantity)
-                                {
-                                  case LteRrcSap::ReportConfigEutra::RSRP:
-                                    mn = storedMeasIt->second.rsrp;
-                                    break;
-                                  case LteRrcSap::ReportConfigEutra::RSRQ:
-                                    mn = storedMeasIt->second.rsrq;
-                                    break;
-                                  default:
-                                    NS_FATAL_ERROR ("unsupported triggerQuantity");
-                                    break;
-                                }
-
-                              // Inequality A5-4 (Leaving condition 2): Mn + Ofn + Ocn + Hys < Thresh2
-
-                              leavingCond = mn + ofn + ocn + hys < thresh2;
-
-                              if (!leavingCond)
-                                {
-                                  CancelLeavingTrigger (measId, cellId);
-                                }
-
-                              /*
-                               * Whatever the result of leaving condition #2, this
-                               * cell is still "in", because leaving condition #1
-                               * is already true.
-                               */
-                              concernedCellsLeaving.push_back (cellId);
-                              eventLeavingCondApplicable = true;
-
-                              NS_LOG_LOGIC (this << " event A5: neighbor cell " << cellId
-                                                 << " mn=" << mn << " mp=" << mp
-                                                 << " thresh2=" << thresh2
-                                                 << " thresh1=" << thresh1
-                                                 << " leavingCond=" << leavingCond);
-
-                            } // end of if (measReportIt->second.cellsTriggeredList.find (cellId)
-                              //            != measReportIt->second.cellsTriggeredList.end ())
-
-                        } // end of for (storedMeasIt)
-
-                    } // end of else of if (reportConfigEutra.timeToTrigger == 0)
-
-                  NS_LOG_LOGIC (this << " event A5: serving cell " << m_cellId
-                                     << " mp=" << mp << " thresh1=" << thresh1
-                                     << " leavingCond=" << leavingCond);
+          } // end of if (entryCond)
+        else
+          {
+            NS_LOG_LOGIC (this << " event A5: serving cell " << m_cellId
+                               << " mp=" << mp << " thresh1=" << thresh1
+                               << " entryCond=" << entryCond);
 
-                } // end of if (leavingCond)
-              else
-                {
-                  if (reportConfigEutra.timeToTrigger > 0)
-                    {
-                      CancelLeavingTrigger (measId);
-                    }
+            if (reportConfigEutra.timeToTrigger > 0)
+              {
+                CancelEnteringTrigger (measId);
+              }
+          }
 
-                  // check leaving condition #2
+        if (isMeasIdInReportList)
+          {
+            // Inequality A5-3 (Leaving condition 1): Mp - Hys > Thresh1
+            bool leavingCond = mp - hys > thresh1;
 
-                  for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
-                       storedMeasIt != m_storedMeasValues.end ();
-                       ++storedMeasIt)
-                    {
-                      uint16_t cellId = storedMeasIt->first;
-                      if (cellId == m_cellId)
-                        {
-                          continue;
-                        }
-
-                      if (measReportIt->second.cellsTriggeredList.find (cellId)
-                          != measReportIt->second.cellsTriggeredList.end ())
-                        {
-                          switch (reportConfigEutra.triggerQuantity)
-                            {
+            if (leavingCond)
+              {
+                if (reportConfigEutra.timeToTrigger == 0)
+                  {
+                    // leaving condition #2 does not have to be checked
+
+                    for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
+                         storedMeasIt != m_storedMeasValues.end ();
+                         ++storedMeasIt)
+                      {
+                        uint16_t cellId = storedMeasIt->first;
+                        if (cellId == m_cellId)
+                          {
+                            continue;
+                          }
+
+                        if (measReportIt->second.cellsTriggeredList.find (cellId)
+                            != measReportIt->second.cellsTriggeredList.end ())
+                          {
+                            concernedCellsLeaving.push_back (cellId);
+                            eventLeavingCondApplicable = true;
+                          }
+                      }
+                  } // end of if (reportConfigEutra.timeToTrigger == 0)
+                else
+                  {
+                    // leaving condition #2 has to be checked to cancel time-to-trigger
+
+                    for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
+                         storedMeasIt != m_storedMeasValues.end ();
+                         ++storedMeasIt)
+                      {
+                        uint16_t cellId = storedMeasIt->first;
+                        if (cellId == m_cellId)
+                          {
+                            continue;
+                          }
+
+                        if (measReportIt->second.cellsTriggeredList.find (cellId)
+                            != measReportIt->second.cellsTriggeredList.end ())
+                          {
+                            switch (reportConfigEutra.triggerQuantity)
+                              {
                               case LteRrcSap::ReportConfigEutra::RSRP:
                                 mn = storedMeasIt->second.rsrp;
                                 break;
@@ -2517,39 +2488,109 @@
                               default:
                                 NS_FATAL_ERROR ("unsupported triggerQuantity");
                                 break;
-                            }
+                              }
 
-                          // Inequality A5-4 (Leaving condition 2): Mn + Ofn + Ocn + Hys < Thresh2
-                          leavingCond = mn + ofn + ocn + hys < thresh2;
+                            // Inequality A5-4 (Leaving condition 2): Mn + Ofn + Ocn + Hys < Thresh2
 
-                          if (leavingCond)
-                            {
-                              concernedCellsLeaving.push_back (cellId);
-                              eventLeavingCondApplicable = true;
-                            }
+                            leavingCond = mn + ofn + ocn + hys < thresh2;
 
-                          NS_LOG_LOGIC (this << " event A5: neighbor cell " << cellId
-                                             << " mn=" << mn << " mp=" << mp
-                                             << " thresh2=" << thresh2
-                                             << " thresh1=" << thresh1
-                                             << " leavingCond=" << leavingCond);
+                            if (!leavingCond)
+                              {
+                                CancelLeavingTrigger (measId, cellId);
+                              }
 
-                        } // end of if (measReportIt->second.cellsTriggeredList.find (cellId)
-                          //            != measReportIt->second.cellsTriggeredList.end ())
+                            /*
+                             * Whatever the result of leaving condition #2, this
+                             * cell is still "in", because leaving condition #1
+                             * is already true.
+                             */
+                            concernedCellsLeaving.push_back (cellId);
+                            eventLeavingCondApplicable = true;
 
-                    } // end of for (storedMeasIt)
+                            NS_LOG_LOGIC (this << " event A5: neighbor cell " << cellId
+                                               << " mn=" << mn << " mp=" << mp
+                                               << " thresh2=" << thresh2
+                                               << " thresh1=" << thresh1
+                                               << " leavingCond=" << leavingCond);
 
-                } // end of else of if (leavingCond)
+                          } // end of if (measReportIt->second.cellsTriggeredList.find (cellId)
+                            //            != measReportIt->second.cellsTriggeredList.end ())
 
-            } // end of if (isMeasIdInReportList)
+                      } // end of for (storedMeasIt)
 
-        } // end of case LteRrcSap::ReportConfigEutra::EVENT_A5
+                  } // end of else of if (reportConfigEutra.timeToTrigger == 0)
 
-        break;
+                NS_LOG_LOGIC (this << " event A5: serving cell " << m_cellId
+                                   << " mp=" << mp << " thresh1=" << thresh1
+                                   << " leavingCond=" << leavingCond);
 
-      default:
-        NS_FATAL_ERROR ("unsupported eventId " << reportConfigEutra.eventId);
-        break;
+              } // end of if (leavingCond)
+            else
+              {
+                if (reportConfigEutra.timeToTrigger > 0)
+                  {
+                    CancelLeavingTrigger (measId);
+                  }
+
+                // check leaving condition #2
+
+                for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
+                     storedMeasIt != m_storedMeasValues.end ();
+                     ++storedMeasIt)
+                  {
+                    uint16_t cellId = storedMeasIt->first;
+                    if (cellId == m_cellId)
+                      {
+                        continue;
+                      }
+
+                    if (measReportIt->second.cellsTriggeredList.find (cellId)
+                        != measReportIt->second.cellsTriggeredList.end ())
+                      {
+                        switch (reportConfigEutra.triggerQuantity)
+                          {
+                          case LteRrcSap::ReportConfigEutra::RSRP:
+                            mn = storedMeasIt->second.rsrp;
+                            break;
+                          case LteRrcSap::ReportConfigEutra::RSRQ:
+                            mn = storedMeasIt->second.rsrq;
+                            break;
+                          default:
+                            NS_FATAL_ERROR ("unsupported triggerQuantity");
+                            break;
+                          }
+
+                        // Inequality A5-4 (Leaving condition 2): Mn + Ofn + Ocn + Hys < Thresh2
+                        leavingCond = mn + ofn + ocn + hys < thresh2;
+
+                        if (leavingCond)
+                          {
+                            concernedCellsLeaving.push_back (cellId);
+                            eventLeavingCondApplicable = true;
+                          }
+
+                        NS_LOG_LOGIC (this << " event A5: neighbor cell " << cellId
+                                           << " mn=" << mn << " mp=" << mp
+                                           << " thresh2=" << thresh2
+                                           << " thresh1=" << thresh1
+                                           << " leavingCond=" << leavingCond);
+
+                      } // end of if (measReportIt->second.cellsTriggeredList.find (cellId)
+                        //            != measReportIt->second.cellsTriggeredList.end ())
+
+                  } // end of for (storedMeasIt)
+
+              } // end of else of if (leavingCond)
+
+          } // end of if (isMeasIdInReportList)
+
+      } // end of case LteRrcSap::ReportConfigEutra::EVENT_A5
+
+      break;
+
+    default:
+      NS_FATAL_ERROR ("unsupported eventId " << reportConfigEutra.eventId);
+      break;
 
     } // switch (event type)
 
@@ -2899,14 +2940,6 @@
   LteRrcSap::MeasResults& measResults = measurementReport.measResults;
   measResults.measId = measId;
 
-  std::map<uint16_t, MeasValues>::iterator servingMeasIt = m_storedMeasValues.find (m_cellId);
-  NS_ASSERT (servingMeasIt != m_storedMeasValues.end ());
-  measResults.rsrpResult = EutranMeasurementMapping::Dbm2RsrpRange (servingMeasIt->second.rsrp);
-  measResults.rsrqResult = EutranMeasurementMapping::Db2RsrqRange (servingMeasIt->second.rsrq);
-  NS_LOG_INFO (this << " reporting serving cell "
-               "RSRP " << (uint32_t) measResults.rsrpResult << " (" << servingMeasIt->second.rsrp << " dBm) "
-               "RSRQ " << (uint32_t) measResults.rsrqResult << " (" << servingMeasIt->second.rsrq << " dB)");
-  measResults.haveMeasResultNeighCells = false;
   std::map<uint8_t, VarMeasReport>::iterator measReportIt = m_varMeasReportList.find (measId);
   if (measReportIt == m_varMeasReportList.end ())
     {
@@ -2914,6 +2947,34 @@
     }
   else
     {
+      std::map<uint16_t, MeasValues>::iterator servingMeasIt = m_storedMeasValues.find (m_cellId);
+      NS_ASSERT (servingMeasIt != m_storedMeasValues.end ());
+      measResults.measResultPCell.rsrpResult = EutranMeasurementMapping::Dbm2RsrpRange (servingMeasIt->second.rsrp);
+      measResults.measResultPCell.rsrqResult = EutranMeasurementMapping::Db2RsrqRange (servingMeasIt->second.rsrq);
+      NS_LOG_INFO (this << " reporting serving cell "
+                   "RSRP " << +measResults.measResultPCell.rsrpResult << " (" << servingMeasIt->second.rsrp << " dBm) "
+                   "RSRQ " << +measResults.measResultPCell.rsrqResult << " (" << servingMeasIt->second.rsrq << " dB)");
+
+      measResults.haveMeasResultServFreqList = false;
+      for (uint8_t componentCarrierId = 1; componentCarrierId < m_numberOfComponentCarriers; componentCarrierId++)
+        {
+          const uint16_t cellId = m_cphySapProvider.at (componentCarrierId)->GetCellId ();
+          auto measValuesIt = m_storedMeasValues.find (cellId);
+          if (measValuesIt != m_storedMeasValues.end ())
+            {
+              measResults.haveMeasResultServFreqList = true;
+              LteRrcSap::MeasResultServFreq measResultServFreq;
+              measResultServFreq.servFreqId = componentCarrierId;
+              measResultServFreq.haveMeasResultSCell = true;
+              measResultServFreq.measResultSCell.rsrpResult = EutranMeasurementMapping::Dbm2RsrpRange (measValuesIt->second.rsrp);
+              measResultServFreq.measResultSCell.rsrqResult = EutranMeasurementMapping::Db2RsrqRange (measValuesIt->second.rsrq);
+              measResultServFreq.haveMeasResultBestNeighCell = false;
+              measResults.measResultServFreqList.push_back (measResultServFreq);
+            }
+        }
+
+      measResults.haveMeasResultNeighCells = false;
+
       if (!(measReportIt->second.cellsTriggeredList.empty ()))
         {
           std::multimap<double, uint16_t> sortedNeighCells;
@@ -2972,28 +3033,6 @@
           NS_LOG_WARN (this << " cellsTriggeredList is empty");
         }
 
-      measResults.haveScellsMeas = false;
-      std::map<uint16_t, MeasValues>::iterator sCellsMeasIt =  m_storedScellMeasValues.begin ();
-      if (sCellsMeasIt != m_storedScellMeasValues.end ())
-        {
-          measResults.haveScellsMeas = true;
-          measResults.measScellResultList.haveMeasurementResultsServingSCells = true;
-          measResults.measScellResultList.haveMeasurementResultsNeighCell = false;
-
-
-          for ( sCellsMeasIt = m_storedScellMeasValues.begin ();
-                sCellsMeasIt != m_storedScellMeasValues.end (); ++sCellsMeasIt)
-            {
-              LteRrcSap::MeasResultScell measResultScell;
-              measResultScell.servFreqId = sCellsMeasIt->first;
-              measResultScell.haveRsrpResult =  true;
-              measResultScell.haveRsrqResult =  true;
-              measResultScell.rsrpResult = EutranMeasurementMapping::Dbm2RsrpRange (sCellsMeasIt->second.rsrp);
-              measResultScell.rsrqResult = EutranMeasurementMapping::Db2RsrqRange (sCellsMeasIt->second.rsrq);
-              measResults.measScellResultList.measResultScell.push_back (measResultScell);
-            }
-        }
-
       /*
        * The current LteRrcSap implementation is broken in that it does not
        * allow for infinite values of reportAmount, which is probably the most
@@ -3225,67 +3264,6 @@
 }
 
 
-void
-LteUeRrc::SaveScellUeMeasurements (uint16_t sCellId, double rsrp, double rsrq,
-                                   bool useLayer3Filtering, uint16_t componentCarrierId)
-{
-  NS_LOG_FUNCTION (this << sCellId << componentCarrierId << rsrp << rsrq << useLayer3Filtering);
-  if (sCellId == m_cellId)
-    {
-
-      std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedScellMeasValues.find (componentCarrierId);
-
-      if (storedMeasIt != m_storedScellMeasValues.end ())
-        {
-          if (useLayer3Filtering)
-            {
-              // F_n = (1-a) F_{n-1} + a M_n
-              storedMeasIt->second.rsrp = (1 - m_varMeasConfig.aRsrp) * storedMeasIt->second.rsrp
-                + m_varMeasConfig.aRsrp * rsrp;
-
-              if (std::isnan (storedMeasIt->second.rsrq))
-                {
-                  // the previous RSRQ measurements provided UE PHY are invalid
-                  storedMeasIt->second.rsrq = rsrq;   // replace it with unfiltered value
-                }
-              else
-                {
-                  storedMeasIt->second.rsrq = (1 - m_varMeasConfig.aRsrq) * storedMeasIt->second.rsrq
-                    + m_varMeasConfig.aRsrq * rsrq;
-                }
-            }
-          else
-            {
-              storedMeasIt->second.rsrp = rsrp;
-              storedMeasIt->second.rsrq = rsrq;
-            }
-        }
-      else
-        {
-          // first value is always unfiltered
-          MeasValues v;
-          v.rsrp = rsrp;
-          v.rsrq = rsrq;
-          std::pair<uint16_t, MeasValues> val (componentCarrierId, v);
-          std::pair<std::map<uint16_t, MeasValues>::iterator, bool>
-          ret = m_storedScellMeasValues.insert (val);
-          NS_ASSERT_MSG (ret.second == true, "element already existed");
-          storedMeasIt = ret.first;
-        }
-
-      NS_LOG_DEBUG (this << " IMSI " << m_imsi << " state " << ToString (m_state)
-                         << ", measured cell " << sCellId
-                         << ", carrier component Id " << componentCarrierId
-                         << ", new RSRP " << rsrp << " stored " << storedMeasIt->second.rsrp
-                         << ", new RSRQ " << rsrq << " stored " << storedMeasIt->second.rsrq);
-      storedMeasIt->second.timestamp = Simulator::Now ();
-    }
-  else
-    {
-      NS_LOG_DEBUG (this << " IMSI " << m_imsi << "measurement on SCC from not serving cell ");
-    }
-
-}   // end of void SaveUeMeasurements
 
 void
 LteUeRrc::RadioLinkFailureDetected ()
@@ -3348,6 +3326,11 @@
   m_cphySapProvider.at (0)->ResetRlfParams ();
 }
 
+const std::string
+LteUeRrc::ToString (LteUeRrc::State s)
+{
+  return g_ueRrcStateName[s];
+}
 
 
 } // namespace ns3
